<?php

namespace Netzmacher\Startgreen\Backend;

use TYPO3\CMS\Core\Utility\VersionNumberUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2018-2019 - Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * @author      Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package     TYPO3
 * @subpackage  startgreen
 * @version 2.12.33
 * @since 2.12.33
 */
class PageTreeIcons
{

	/**
	 * @access public
	 * @return      void
	 * @version     2.12.33
	 * @since       2.12.33
	 */
	static public function Render()
	{
		$TYPO3_version = VersionNumberUtility::convertVersionNumberToInteger( TYPO3_version );

		switch( TRUE )
		{
			case ( $TYPO3_version < 8007000 ):
				SELF::_Render76();
				break;
			case ( $TYPO3_version >= 8007000 ):
			default:
				SELF::_Render87();
				break;
		}
	}

	/**
	 * @access private
	 * @return      void
	 * @version     2.12.33
	 * @since       2.12.33
	 */
	static private function _Render76()
	{
		global $TCA;
		
		$path = \Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( 'startgreen' );
		$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array( 'TYPO3 Grüne', 'startgreen', $path . 'ext_icon.svg' );

// Case $llStatic
//  #34858, 120320, dwildt
		\TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon( 'pages', 'contains-startgreen', '../typo3conf/ext/startgreen/ext_icon.svg' );
	}

	/**
	 * @access private
	 * @return      void
	 * @version     2.12.33
	 * @since       2.12.33
	 */
	static private function _Render87()
	{
		global $TCA;
		
		$extIconPath = 'EXT:startgreen/Resources/Public/Images/Icons/ExtIcon/';
		$extLLLPath = 'LLL:EXT:startgreen/Resources/Private/Language/';

		$extIcons = array(
				'default' => array(
						'identifier' => 'contains-default'
						, 'key' => 'default' // <- Key must be the part behind contains- of the identifier!
						, 'label' => $extLLLPath . 'pagetreeicons.xlf:default'
						, 'source' => $extIconPath . 'default.svg'
				),
				'sunflower' => array(
						'identifier' => 'contains-sunflower'
						, 'key' => 'sunflower' // <- Key must be the part behind contains- of the identifier!
						, 'label' => $extLLLPath . 'pagetreeicons.xlf:sunflower'
						, 'source' => $extIconPath . 'sunflower.svg'
				),
		);

		$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Imaging\IconRegistry::class );

		foreach( ( array ) $extIcons as $extIcon )
		{
			$iconRegistry->registerIcon(
							$extIcon[ 'identifier' ]
							, \TYPO3\CMS\Core\Imaging\IconProvider\SVGIconProvider::class
							, [ 'source' => $extIcon[ 'source' ] ]
			);
			$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array(
					$extIcon[ 'label' ]
					, $extIcon[ 'key' ]
					, $extIcon[ 'identifier' ]
			);
			$TCA[ 'pages' ][ 'ctrl' ][ 'typeicon_classes' ][ $extIcon[ 'identifier' ] ] = $extIcon[ 'identifier' ];
		}
	}

}